var base, formData, setProperty, submit;

$(function() {
  var $confirmed, $form, $photo, photo;
  photo = [];
  $photo = $('p.photo').prev();
  if (($confirmed = $('.confirmed')).length > 0) {
    submit({
      confirm: 'd869db7f'
    }, function(error, data) {
      if (!error) {
        return $confirmed.show();
      }
    });
  }
  $('button.photo').on('click', function(event) {
    event.preventDefault();
    return $('#photo').val('').click();
  });
  $('#photo').on('change', function(event) {
    var file, sha1;
    $('form.main').addClass("busy");
    file = $('#photo')[0].files[0];
    sha1 = null;
    return fetch("https://api.test.leptonix.net/blob/komo", {
      method: "POST"
    }).then(function(response) {
      return response.json();
    }).then(function(arg) {
      var fields, formData, key, url, value;
      url = arg.url, fields = arg.fields;
      sha1 = fields.key.slice(10);
      formData = new FormData;
      for (key in fields) {
        value = fields[key];
        formData.append(key, value);
      }
      formData.append("Content-Type", file.type);
      formData.append("file", file);
      return fetch(url, {
        method: "POST",
        body: formData
      });
    }).then(function(response) {
      console.log(response);
      $('form.main').removeClass("busy");
      photo.push(sha1);
      if (photo.length >= 3) {
        $('p.photo').remove();
      }
      return $photo.append($("<p><label>Foto</label><img src=\"/blob/komo/" + sha1 + "\"></p>"));
    });
  });
  return ($form = $("form.main")).submit(function(event) {
    var form;
    event.preventDefault();
    form = formData($form);
    if (photo != null ? photo.length : void 0) {
      form.data.photo = photo;
    }
    return submit(form);
  });
});

submit = function(form, callback) {
  var id, m, ref;
  if ((m = window.location.href.match(/form=([^&]+)/))) {
    id = m[1];
  }
  return $.ajax({
    url: id ? "/data/" + id : "/data",
    type: id ? "PUT" : "POST",
    contentType: "application/json",
    data: JSON.stringify((ref = form.data) != null ? ref : form),
    success: function(data, status, request) {
      if (callback) {
        return callback(null, data);
      } else {
        if (id == null) {
          id = request.responseText;
        }
        return window.location.href = form.next ? form.next + ("?form=" + id) : "https://w0wt1f9vl5.execute-api.eu-west-1.amazonaws.com/omega/verify?" + (btoa(JSON.stringify({
          id: id,
          email: form.data.email,
          name: form.data.name
        })));
      }
    },
    error: function(req, status, message) {
      var error;
      error = {
        req: req,
        status: status,
        message: message
      };
      if (callback) {
        return callback(error);
      } else {
        return console.error(error);
      }
    }
  });
};

formData = function(form) {
  var data, incomplete;
  incomplete = false;
  data = {};
  $.each($(form).serializeArray(), function() {
    var input, ref, ref1, ref2, value;
    value = (ref = (ref1 = ((ref2 = this.value) != null ? ref2 : "").match(/^\s*(.*?)\s*$/)) != null ? ref1[1] : void 0) != null ? ref : this.value;
    input = $(":input[name='" + this.name + "']", form);
    input.closest("p").removeClass("unknown");
    if (value !== "" || !input.hasClass("required")) {
      input.closest("p").removeClass("missing");
      if (this.name === 'data.certificate_number') {
        if (value != null) {
          value = value.toUpperCase();
        }
        switch (value) {
          case '32727':
          case '32673':
            data.data.certificate_holder = 'sphere';
            break;
          case '33059':
          case '33060':
            data.data.certificate_holder = 'colpack';
            break;
          case '32993':
          case '32994':
            data.data.certificate_holder = 'cedo';
            break;
          case 'K58286':
          case 'K40816':
            data.data.certificate_holder = 'jong';
            break;
          case 'K52697':
          case 'K88711':
            data.data.certificate_holder = 'dimensio';
            break;
          case '33437':
            data.data.certificate_holder = 'quickpack';
            break;
          default:
            input.closest('p').addClass('unknown');
            incomplete = true;
        }
      }
      return setProperty(data, this.name.split("."), value);
    } else {
      input.closest("p").addClass("missing");
      return incomplete = true;
    }
  });
  if (!incomplete || data.finish) {
    return data;
  }
};

setProperty = function(a, path, value) {
  path.reduce(function(a, key, i) {
    if (i < path.length - 1) {
      return a[key] != null ? a[key] : a[key] = {};
    } else {
      return a[key] = value;
    }
  }, a);
  return a;
};

if ((base = Array.prototype).reduce == null) {
  base.reduce = function(f, a) {
    var i, n;
    n = this.length;
    i = -1;
    while (++i < n) {
      a = f(a, this[i], i);
    }
    return a;
  };
}
